proc Window {name args} {if ![string compare :: $name] {return [eval Window_[lindex $args 0] [lrange $args 1 end]]}
set ln [string tolower $name]
set this [objName Window]
initObj $this Window
uplevel #0 set WTO($ln) $this
upvar #0 $this wdata
set wdata(name) $ln
proc $this args "eval window_call $this \$args"
toplevel $ln -class Zircon
wm resizable $ln 1 1
wm protocol $ln WM_DELETE_WINDOW "$this close"
if ![string match {} $args] {eval $this configure $args}
return $this}
proc Window_id win {global WTO
if [info exists WTO([set w [winfo toplevel $w]in])] {return $WTO($w)}
return nil}
proc window_call {this op args} {upvar #0 $this wdata
if [info exists wdata($op)] {return $wdata($op)}
return [eval window_$op $this $args]}
proc window_extendTime this {upvar #0 $this wdata
set wdata(closecount) $wdata(closetime)}
proc window_setTitle {this chan title} {if [string compare [set win [$this name]] [$chan window]] {retitleFrame [$this name] $chan $title} {wm title $win $title}}
proc window_setIcon {this chan title} {global Icon
switch -- [set win [$this name]] [$chan window] {wm iconname $win $title
set Icon($win) $title
switch {} [set icn [$chan icon]] {} default {global IconBM
set IconBM($win) $icn
wm iconbitmap $win [lindex $icn 0]}} default {}}
proc window_noPopUp {this chan} {switch -- [set win [$this name]] [$chan window] {global Icon IconBM
catch {wm iconname $win "*$Icon($win)*"}
if {[info exists IconBM($win)] && ![string match {} [set icn [lindex $IconBM($win) 1]]]} {wm iconbitmap $win $icn}}}
proc window_popup this {wm deiconify [set w [$this name]]
raise $w}
proc window_close this {upvar #0 $this wdata
foreach x $wdata(children) {eval [lindex $x 1]}}
proc window_delete this {global WTO Icon IconBM Otype
set w [$this name]
catch {bind $w.cFrm <Destroy> {}}
catch {unset WTO($w) Icon($w) IconBM($w)}
foreach v OType {catch {unset ${v}($this)}}
uplevel #0 unset $this
rename $this {}
destroy $w}
proc window_iconify this {wm iconify [$this name]}
proc window_configure {this args} {upvar #0 $this wdata
while {![string match {} $args]} {set val [lindex $args 1]
set name [lindex $args 0]
set opt [string range $name 1 end]
switch -glob -- $name {-title - -iconname - -iconbitmap {wm $opt [$this name] $val} -geometry - -resizable {eval wm $opt [$this name] $val} +* {lappend wdata($opt) $val} -* {set wdata($opt) $val}}
set args [lrange $args 2 end]}}
proc window_register {this id lcmd dcmd} {upvar #0 $this wdata
lappend wdata(children) [list $id $lcmd $dcmd]}
proc window_deregister {this id} {upvar #0 $this wdata
if {[set x [lsearch $wdata(children) "$id *"]] >= 0} {eval [lindex [lindex $wdata(children) $x] 2]
listdel wdata(children) $x}
if [string match {} $wdata(children)] {$this delete}}
proc Window_find name {global WTO
set ln [string tolower $name]
return [expr {[info exists WTO($ln)] ? $WTO($ln) : {nil}}]}
proc Window_make name {global WTO
set ln [string tolower $name]
if [info exists WTO($ln)] {return $WTO($ln)}
return [Window $name]}
