proc preferences {op val} {}
proc net {var val} {global currentNet DEBUG
switch -glob -- $var {trust* {regsub {\(} $var "\($currentNet," var
uplevel #0 set $var "{$val}"} DEBUG {set DEBUG $val} zircon(ping) {$currentNet configure -ping [expr $val *1000]} zircon(multion) - zircon(beep) - zircon(autochat) - zircon(busymsg) - zircon(autoget) - zircon(images) - zircon(raw) - zircon(command) - zircon(wavplayer) - zircon(wavpath) - zircon(nicksize) - zircon(antiflood) - zircon(ircIImode) - zircon(nosplit) - zircon(reconnect) {regexp {.*\((.*)\)} $var m op
$currentNet configure -$op $val} zircon* {uplevel #0 set $var "{$val}"} default {$currentNet configure -$var $val}}}
proc away args {global currentNet
$currentNet configure +aways [join $args]}
proc nick args {global currentNet
$currentNet configure +nicks [join $args]}
proc ircname args {global currentNet
$currentNet configure +ircnames [join $args]}
proc action args {global currentNet
$currentNet configure +actions [join $args]}
proc leave args {global currentNet
$currentNet configure +leaves [join $args]}
proc signoff args {global currentNet
$currentNet configure +signoffs [join $args]}
proc zbind {chan sequence action} {if [string match {} $chan] {global currentNet
$currentNet configure +bindings [list $sequence $action]} {[Channel :: make $chan $net] configure +bindings [list $sequence $action]}}
proc srvName {srv net} {if [regexp {(.*):(.*)} $srv m hst prt] {switch nil [set sid [Server :: make $hst $net]] {set sid [Server $hst -port $prt]} default {switch [$sid port] $prt {} default {set sid [Server [newName srv] -host $hst -port $prt]}}} {set sid [Server :: make $srv $net]}
return $sid}
proc setCE {var val evar} {global env
if ![string match {} $val] {uplevel set $var "{$val}"
return 1} elseif {[info exists env($evar)]} {uplevel set $var "{$env($evar)}"
return 1}
return 0}
proc envCheck {arg evar op dflt} {global env currentNet
set lst [$currentNet $op]
if [setCE v $arg $evar] {if {[set x [lsearch $lst $v]] > 0} {listdel lst $x}
$currentNet configure -$op [linsert $lst 0 $v]} elseif {[string match {} $lst]} {$currentNet configure -$op $dflt}}
proc layout {net window geom} {uplevel #0 set zlayout($net,$window) $geom}
proc srcit {file what} {if [file exists $file] {if [catch {uplevel #0 source \{$file\}} msg] {puts stderr "**** Error in the $what file - $msg"
bgerror Error
exit 1}
return 1}
return 0}
proc InitDraw {} {global zircon DIms
set f [file join $zircon(lib) gifs]
foreach x {arc none polygon text line oval rectangle} {set DIms($x) [image create photo -file [file join $f $x.gif]]}}
proc Initialise {} {global argv zircon defaults DEBUG currentNet defaultNet
array set zircon {
	nameCount 0
	idle	0
	C	0
	j	0
	o	0
	z	0
	i	{}
	N	{}
	S	{}
	p	{}
    }
wm withdraw .
set h [winfo screenheight .]
set w [winfo screenwidth .]
if [string match {*#*} [winfo name .]] {if ![askUser {} Duplicate {You have another copy of zircon running. This may cause some problems with the appearance of this run.
Continue?}] {exit}}
image create photo advert -file [file join $zircon(lib) gifs zircon.gif]
set iw [image width advert]
set ih [image height advert]
toplevel .ad
wm overrideredirect .ad 1
wm geometry .ad ${iw}x${ih}+[expr ($w -$ih) /2]+[expr ($h - $ih)/2]
pack [label .ad.l -image advert -borderwidth 2 -relief raised]
after 3000 { catch {destroy .ad} }
update
source [file join $zircon(lib) lib Classes.tcl]
foreach ty {Entry Text Button} {foreach x [bind $ty] {bind $ty $x {+ notIdle %W}}}
if [file exists [file join $zircon(lib) zircon.ad]] {option readfile [file join $zircon(lib) zircon.ad] startupFile}
option add *Checkbutton*relief flat widgetDefault
option add *Checkbutton*borderwidth 0 widgetDefault
option add *CheckButton*padX 5 widgetDefault
option add *CheckButton*padY 4 widgetDefault
option add *CheckButton*highlightThickness 0 widgetDefault
option add *Button*padX 5 widgetDefault
option add *Button*padY 4 widgetDefault
option add *Button*highlightThickness 0 widgetDefault
option add *Menubutton*padX 5 widgetDefault
option add *Menubutton*pady 4 widgetDefault
option add *Menubutton*relief raised widgetDefault
option add *Frame*borderWidth 2 widgetDefault
option add *Scrollbar*relief raised widgetDefault
option add *Listbox*relief raised widgetDefault
option add *Entry*relief raised widgetDefault
option add *Entry*highlighThickness 1 widgetDefault
option add *Text*setGrid 1 widgetDefault
option add *Text*wrap word widgetDefault
option add *Text*relief raised widgetDefault
option add *Text*exportSelection 1 widgetDefault
option add *Canvas*relief raised widgetDefault
foreach x [bind Text] {bind ROText $x [bind Text $x]}
foreach x {<KeyPress-F20> <KeyPress-F18> <Tab> <Control-i> <Return> <Delete> <BackSpace> <Insert> <KeyPress> <Control-d> <Control-k> <Control-o> <Control-t> <Meta-BackSpace> <Meta-Delete> <Control-h> <ButtonRelease-2>} {bind ROText $x {}}
array set zircon "
	tmp		{[tmpdir]}
	bellcmd		bell
	envnick		IRCNICK
	envname		IRCNAME
	envserver	IRCSERVER
	envport		IRCPORT
	prefdir		{[prefdir]}
	language	english
	look		standard
	action		Shift-Return
	sepColor	red
	ignore		{Notices Public Invites Wallops Notes CTCP Others}
	scriptpath	{[file join $zircon(lib) scripts]}
	pluginpath	{[file join $zircon(lib) plugins]}
	serversStyle	pulldown
	usersStyle	pulldown
    "
array set defaults [array get zircon]
array set zircon {
	version		1.18
	patchlevel	a38
    }
set DEBUG 0
set opts {}
foreach arg $argv {if [string match {-*} $arg] {foreach bit [split [string range $arg 1 end]] {switch $bit {C - j - o - z {set zircon($bit) 1} d - r - i - N - S - p {lappend opts $bit} D {set DEBUG 1} default {puts stderr "Unknown option -$bit"}}}} {set opt [lindex $opts 0]
set opts [lrange $opts 1 end]
switch $opt {i - N - S - r - p {set zircon($opt) $arg} default {}}}}
set defaultNet [set currentNet [Net default]]
InitLook
InitDraw
after 600000 schedGC}
proc makeDefaults net {global defChan defChat defMsg defNotice
set defChan($net) [Channel *default*]
set defChat($net) [Chat *default* -height 10]
set defMsg($net) [Message *default* -height 10]
set defNotice($net) [Notice *default* -height 10]}
proc InitGlobals {} {global env zircon defaults user trust
upvar #0 currentNet net
getOption smiley ":-\)"
getOption scowl ":-\("
getOption wink ";-\)"
array set trust {
	eval	{}
	draw	.+
    }
makeDefaults $net
makeArray TFg TBg TAF TAB TSplit Heal Split MkOp OnCode Host Shost Share
set user [username]
srcit [file join $zircon(lib) lang english.tcl] "the system Zircon english message"
global DEBUG hostIPaddress
catch {set hostIPaddress $env(HOSTIPADDR)}
if ![srcit [file join $zircon(prefdir) look $zircon(look).tcl] "your Zircon $zircon(look) look"] {srcit [file join $zircon(lib) look $zircon(look).tcl] "the system Zircon $zircon(look)"}
switch english $zircon(language) {} default {srcit [file join $zircon(lib) lang $zircon(language).tcl] "system Zircon $zircon(language) message"}
srcit [file join $zircon(prefdir) lang $zircon(language).tcl] "your Zircon $zircon(language) message"
srcit [file join $zircon(prefdir) layout] "your Zircon layout"
MainControl
MainInfo
catch {set zircon(prefdir) $env(ZIRCONPREFDIR)}
if [info exists zircon(d)] {set zircon(prefdir) $zircon(d)}
if !$zircon(z) {if [info exists zircon(r)] {srcit $zircon(r) "your $zircon(r)"} {set sp $zircon(prefdir)
if [srcit [file join $zircon(lib) rc] {the system rc}] {foreach sv [$net servers] {$sv configure -sys 1}
foreach sv [$net services] {$sv configure -sys 1}
foreach sv [$net channels] {$sv configure -sys 1}
uplevel #0 \$defChan($net) configure -sys 0}
set zircon(prefdir) $sp
if ![srcit [file join $zircon(prefdir) preferences] "your [file join $zircon(prefdir) preferences]"] {if [srcit [file join ~ .zirconrc] {your .zirconrc}] {upgradeRC}}}}
envCheck $zircon(N) $zircon(envnick) nicks $user
envCheck $zircon(i) $zircon(envname) ircnames %u@%h
InitNet $net
set nets [Net :: list]
if {[llength $nets] <= 2} {set dnet [lindex $nets end]
set srv nil
if ![string match {} $zircon(S)] {set srv [srvName $zircon(S) $dnet]} elseif {[info exists env($zircon(envserver))]} {foreach v [split $env($zircon(envserver))] {lappend sid [srvName $v $dnet]}
set srv [lindex $sid 0]} elseif {![string compare nil [$dnet hostid]]} {if ![string compare nil [set srv [Server :: find default $dnet]]] {set zircon(C) 2}}
switch nil $srv {} default {$dnet configure -hostid $srv}}
versionCheck
if $DEBUG zDBGControl
tkwait visibility .@ctl
checkHeight .@ctl
bind .@ctl <Configure> {checkHeight [winfo toplevel %W]}}
set cfgv {showLocal showPublic showPrivate topicOnly
  minMembers friendsStyle helpService friendsOn monitorTime
  verboseCTCP noRefresh killPath showFriends noConfirm toInfo
  noPopup popInfo topicPattern listPattern wallops srvmsg 
  invisible notifyInterval testTime autoget autochat
}
proc InitNet net {global zircon trust defaultNet cfgv defChan user host
set notdf [string compare $net $defaultNet]
foreach x {eval draw} {if ![info exists trust($net,$x)] {if [info exists trust($defaultNet,$x)] {set trust($net,$x) $trust($defaultNet,$x)} {set trust($net,$x) $trust($x)}}}
if [$net raw] {$net configure -command 1}
if $notdf {global Net currentNet
set sc $currentNet
set currentNet $net
foreach x {nick ircname away action leave signoff} {foreach y [$defaultNet ${x}s] {$x $y}}
set currentNet $sc
array set ndefs $Net
foreach x [array names ndefs] {set v [$net $x]
set dv [$defaultNet $x]
if {[string compare $v $dv] && ![string compare $v $ndefs($x)]} {$net configure -$x $dv}}
switch {} [$net nicks] {$net configure -nicks $user}
switch {} [$net ircnames] {$net configure -ircnames %u@%h}}
foreach x [$net users] {Friend [$x name] -notify [$x notify] -id [$x id]
$x delete}
foreach x [$net channels] {$x configure -keep 1}
foreach x [$net messages] {$x configure -keep 1}
set alert 0
foreach x $cfgv {global $x
if [info exists $x] {if !$alert {bell
tk_dialog .@wa Warning "The preferences file format  has changed slightly - please re-save your preferences" warning 0 ok
set alert 1}
$net configure -$x [set $x]}}
$net configure -closeTime [expr [$defChan($net) closetime] * 1000]}
array set cVars {
    IRC		{nicks ircnames}
    Channels	{}
    People	{ignores showFriends friendsOn}
    Info	{showLocal showPublic showPrivate topicOnly minMembers  noConfirm toInfo popInfo verboseCTCP helpService  noPopup noRefresh killPath listPattern topicPattern  notifyInterval}
    Others	{aways actions invisible wallops srvmsg leaves  signoffs monitorTime testTime autoget autochat ping
		 nicksize monitorOut monitorIn
		}
}
array set confData {
    channel	{{{Auto Join} join} {{Pop Up} open}  {{Pop Down} close} {{On Menu} menu} {Draw draw}  {Jump jump} {Quiet quiet} {{Nocase} nocase}}
    single	{multion beep nosplit ircIImode busymsg wavplayer wavpath  images command raw helpService wallops srvmsg invisible  showPublic showLocal showPrivate topicOnly minMembers maxMembers  sorted showFriends undernet listPattern topicPattern friendsStyle  friendsOn monitorTime testTime closeTime notifyInterval  verboseCTCP noRefresh killPath noPopup popInfo busy ping  reconnect srvcycle nicksize monitorIn monitorOut  ctcpPattern antiflood  maxQueue autoAway nocontrol
		}
}
proc versionCheck {} {global zircon
set f [file join $zircon(prefdir) version]
if {[catch {source $f}] || ![info exists currentVersion] || [string compare $currentVersion $zircon(version)$zircon(patchlevel)]} {displayAlert
if ![file exist $zircon(prefdir)] {puts mkdir
if [catch {filemkdir $zircon(prefdir)} msg] {tellError {} Version "Cannot create preferences directory - $fd"
return}}
if [catch {open $f w} fd] {tellError {} Version "Cannot write version file - $fd"} {puts $fd "set currentVersion $zircon(version)$zircon(patchlevel)"
close $fd}}}
proc displayAlert {} {tellInfo {New Version} "This is an alpha test version of the Zircon IRC client. Things may not work as you expect! 
You have been warned!
The away stuff has been changed...
As usual, thanks to you all.
L."}
if [string match {7.[67]} [info tclversion]] {proc filerename {f1 f2} {file rename -force $f1 $f2}
proc filemkdir f1 {file mkdir $f1}
proc filedelete f1 {file delete $f1}} {proc filerename {f1 f2} {exec mv $f1 $f2}
proc filemkdir f1 {exec mkdir $f1}
proc filedelete f1 {exec rm $f1}
rename file _file
proc file {op args} {switch $op {join {return [join $args /]} default {return [uplevel _file $op $args]}}}}
proc schedGC {} {after idle garbageCollect}
proc garbageCollect {} {foreach net [Net :: list] {foreach usr [$net users] {if {[$usr refcount] <= 0} {$usr delete}}}
after 600000 schedGC}
